Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.axis.client
Class Call

    java.lang.Object
      org.apache.axis.client.Call

All Implemented Interfaces:
  javax.xml.rpc.Call

public class Call
extends Object
implements javax.xml.rpc.Call

Axis' JAXRPC Dynamic Invocation Interface implementation of the Call interface. This class should be used to actually invoke the Web Service. It can be prefilled by a WSDL document (on the constructor to the Service object) or you can fill in the data yourself.

     Standard properties defined by in JAX-RPC's javax..xml.rpc.Call interface:
         USERNAME_PROPERTY        - User name for authentication
         PASSWORD_PROPERTY        - Password for authentication
         SESSION_PROPERTY         - Participate in a session with the endpoint?
         OPERATION_STYLE_PROPERTY - "rpc" or "document"
         SOAPACTION_USE_PROPERTY  - Should SOAPAction be used?
         SOAPACTION_URI_PROPERTY  - If SOAPAction is used, this is that action
         ENCODING_STYLE_PROPERTY  - Default is SOAP 1.1:  "http://schemas.xmlsoap.org/soap/encoding/"

     AXIS properties:
         SEND_TYPE_ATTR - Should we send the XSI type attributes (true/false)
         TIMEOUT        - Timeout used by transport sender in milliseconds
         TRANSPORT_NAME - Name of transport handler to use
         ATTACHMENT_ENCAPSULATION_FORMAT- Send attachments as MIME the default, or DIME.

Author:
  Doug Davis (dug@us.ibm.com)

Field Summary
`static String` | `ATTACHMENT_ENCAPSULATION_FORMAT` Property for setting attachment format.
`static String` | `ATTACHMENT_ENCAPSULATION_FORMAT_DIME` Property value for setting attachment format as DIME.
`static String` | `ATTACHMENT_ENCAPSULATION_FORMAT_MIME` Property value for setting attachment format as MIME.
`protected Vector` | `attachmentParts`
`static boolean` | `FAULT_ON_NO_RESPONSE`
`static String` | `JAXRPC_PORTTYPE_NAME`
`static String` | `JAXRPC_SERVICE`
`protected MessageContext` | `msgContext`
`static String` | `SEND_TYPE_ATTR`
`static String` | `TRANSPORT_NAME`
`static String` | `TRANSPORT_PROPERTY`
`static String` | `WSDL_PORT_NAME`
`static String` | `WSDL_SERVICE`

Fields inherited from interface javax.xml.rpc.Call
`ENCODINGSTYLE_URI_PROPERTY, OPERATION_STYLE_PROPERTY, PASSWORD_PROPERTY, SESSION_MAINTAIN_PROPERTY, SOAPACTION_URI_PROPERTY, SOAPACTION_USE_PROPERTY, USERNAME_PROPERTY`

Constructor Summary
`Call(Service service)` Default constructor - not much else to say.
`Call(String url)` Build a call from a URL string
`Call(URL url)` Build a call from a URL

Method Summary
`void` | `addAttachmentPart(Object attachment)` This method adds an attachment.
`protected void` | `addAttachmentParts(Message msg)` Stub out to allow ws4ee layer to add attachments to the message
`void` | `addFault(javax.xml.namespace.QName qname, Class cls, javax.xml.namespace.QName xmlType, boolean isComplex)` Add a fault for this operation Note: Not part of JAX-RPC specificaion
`void` | `addHeader(SOAPHeaderElementAxisImpl header)` Add a header which should be inserted into each outgoing message we generate.
`void` | `addParameter(javax.xml.namespace.QName paramName, javax.xml.namespace.QName xmlType, Class javaType, javax.xml.rpc.ParameterMode parameterMode)` Adds the specified parameter to the list of parameters for the operation associated with this Call object.
`void` | `addParameter(javax.xml.namespace.QName paramName, javax.xml.namespace.QName xmlType, Class javaType, javax.xml.rpc.ParameterMode parameterMode, boolean inHeader, boolean outHeader)` Adds the specified parameter to the list of parameters for the operation associated with this Call object.
`void` | `addParameter(javax.xml.namespace.QName paramName, javax.xml.namespace.QName xmlType, javax.xml.rpc.ParameterMode parameterMode)` Adds the specified parameter to the list of parameters for the operation associated with this Call object.
`void` | `addParameter(String paramName, javax.xml.namespace.QName xmlType, Class javaType, javax.xml.rpc.ParameterMode parameterMode)` Adds a parameter type and mode for a specific operation.
`void` | `addParameter(String paramName, javax.xml.namespace.QName xmlType, javax.xml.rpc.ParameterMode parameterMode)` Adds the specified parameter to the list of parameters for the operation associated with this Call object.
`void` | `addParameterAsHeader(javax.xml.namespace.QName paramName, javax.xml.namespace.QName xmlType, Class javaType, javax.xml.rpc.ParameterMode parameterMode, javax.xml.rpc.ParameterMode headerMode)` Adds a parameter type as a soap:header.
`static void` | `addTransportPackage(String packageName)` Add a package to the system protocol handler search path.
`void` | `clearHeaders()` Clear the list of headers which we insert into each message Note: Not part of JAX-RPC specification.
`void` | `clearOperation()`
`String` | `getEncodingStyle()` Returns the encoding style as a URI that should be used for the SOAP message.
`boolean` | `getMaintainSession()` Get the value of maintainSession flag.
`MessageContext` | `getMessageContext()` Obtain a reference to our MessageContext.
`OperationDesc` | `getOperation()`
`javax.xml.namespace.QName` | `getOperationName()` Returns the operation name associated with this Call object.
`Style` | `getOperationStyle()` Get the operation style.
`Use` | `getOperationUse()` Get the operation use.
`Map` | `getOutputParams()` Get the output parameters (if any) from the last invocation.
`List` | `getOutputValues()` Returns a List values for the output parameters of the last invoked operation.
`javax.xml.namespace.QName` | `getParameterTypeByName(String paramName)` Return the QName of the type of the parameters with the given name.
`javax.xml.namespace.QName` | `getParameterTypeByQName(javax.xml.namespace.QName paramQName)` Return the QName of the type of the parameters with the given name.
`String` | `getPassword()` Get the password
`javax.xml.namespace.QName` | `getPortName()` Returns the fully qualified name of the port for this Call object (if there is one).
`javax.xml.namespace.QName` | `getPortTypeName()` Deprecated. This is really the service's port name, not portType name. Use getPortName instead.
`Object` | `getProperty(String name)` Returns the value associated with the named property
`Iterator` | `getPropertyNames()`
`Message` | `getResponseMessage()` Directly get the response message in our MessageContext.
`javax.xml.namespace.QName` | `getReturnType()` Returns the QName of the type of the return value of this Call - or null if not set.
`Object` | `getScopedProperty(String name)` Deprecated.
`Service` | `getService()` Get the Service object associated with this Call object.
`String` | `getSOAPActionURI()` Get the soapAction URI.
`String` | `getTargetEndpointAddress()` Returns the URL of the target Web Service.
`Integer` | `getTimeout()`
`Transport` | `getTransportForProtocol(String protocol)` Get the Transport registered for the given protocol.
`TypeMapping` | `getTypeMapping()`
`String` | `getUsername()` Get the user name
`protected String` | `getWsdlOpName(String javaOpName)` The default implementation simply returns the java operation name.
`static void` | `initialize()` Set up the default transport URL mappings.
`void` | `invoke()` Invoke this Call with its established MessageContext (perhaps because you called this.setRequestMessage()) Note: Not part of JAX-RPC specification.
`Object` | `invoke(Object[] params)` Invokes the operation associated with this Call object using the passed in parameters as the arguments to the method.
`Object` | `invoke(javax.xml.namespace.QName operationName, Object[] params)` Invokes a specific operation using a synchronous request-response interaction mode.
`Object` | `invoke(RPCElement body)` Invoke an RPC service with a pre-constructed RPCElement.
`SOAPEnvelopeAxisImpl` | `invoke(SOAPEnvelopeAxisImpl env)` Invoke the service with a custom SOAPEnvelope.
`Object` | `invoke(String method, Object[] args)` Convenience method to invoke a method with a default (empty) namespace.
`Object` | `invoke(String namespace, String method, Object[] args)` Invoke an RPC service with a method name and arguments.
`void` | `invokeOneWay(Object[] params)` Invokes the operation associated with this Call object using the passed in parameters as the arguments to the method.
`boolean` | `isParameterAndReturnSpecRequired(javax.xml.namespace.QName operationName)` Is the caller required to provide the parameter and return type specification? If true, then addParameter and setReturnType MUST be called to provide the meta data.
`boolean` | `isPropertySupported(String name)`
`void` | `registerTypeMapping(Class javaType, javax.xml.namespace.QName xmlType, Class sfClass, Class dfClass)`
`void` | `registerTypeMapping(Class javaType, javax.xml.namespace.QName xmlType, Class sfClass, Class dfClass, boolean force)`
`void` | `registerTypeMapping(Class javaType, javax.xml.namespace.QName xmlType, SerializerFactory sf, DeserializerFactory df)` Register type mapping information for serialization/deserialization Note: Not part of JAX-RPC specification.
`void` | `registerTypeMapping(Class javaType, javax.xml.namespace.QName xmlType, SerializerFactory sf, DeserializerFactory df, boolean force)` Register type mapping information for serialization/deserialization Note: Not part of JAX-RPC specification.
`void` | `removeAllParameters()` Clears the list of parameters.
`void` | `removeProperty(String name)` Removes (if set) the named property.
`void` | `removeScopedProperty(String name)` Deprecated.
`void` | `setClientHandlers(Handler reqHandler, Handler respHandler)` Sets the client-side request and response Handlers.
`void` | `setEncodingStyle(String namespaceURI)` Sets the encoding style to the URL passed in.
`void` | `setMaintainSession(boolean yesno)` Determine whether we'd like to track sessions or not.
`void` | `setOperation(OperationDesc operation)` Hand a complete OperationDesc to the Call, and note that this was done so that others don't try to mess with it by calling addParameter, setReturnType, etc.
`void` | `setOperation(javax.xml.namespace.QName portName, String opName)` prefill as much info from the WSDL as it can.
`void` | `setOperation(String opName)` Prefill as much info from the WSDL as it can.
`void` | `setOperationName(javax.xml.namespace.QName opName)` Sets the operation name associated with this Call object.
`void` | `setOperationName(String opName)` This is a convenience method.
`void` | `setOperationStyle(String operationStyle)` Set the operation style: "document", "rpc"
`void` | `setOperationStyle(Style operationStyle)` Set the operation style
`void` | `setOperationUse(String operationUse)` Set the operation use: "literal", "encoded"
`void` | `setOperationUse(Use operationUse)` Set the operation use
`void` | `setOption(String name, Object value)` Set engine option.
`void` | `setPassword(String password)` Set the password.
`void` | `setPortName(javax.xml.namespace.QName portName)` Sets the port name of this Call object.
`void` | `setPortTypeName(javax.xml.namespace.QName portType)` Deprecated. This is really the service's port name, not portType name. Use setPortName instead.
`void` | `setProperty(String name, Object value)` Allows you to set a named property to the passed in value.
`void` | `setRequestMessage(Message msg)` Directly set the request message in our MessageContext.
`void` | `setReturnClass(Class cls)` Sets the desired return Java Class.
`void` | `setReturnQName(javax.xml.namespace.QName qname)` Set the QName of the return element NOT part of JAX-RPC
`void` | `setReturnType(javax.xml.namespace.QName returnType)` Sets the return type of the operation associated with this Call object.
`void` | `setReturnType(javax.xml.namespace.QName xmlType, Class javaType)` Sets the return type for a specific operation.
`void` | `setReturnTypeAsHeader(javax.xml.namespace.QName xmlType)` Set the return type as a header
`void` | `setReturnTypeAsHeader(javax.xml.namespace.QName xmlType, Class javaType)` Set the return type as a header
`void` | `setScopedProperty(String name, Object value)` Deprecated.
`void` | `setSOAPActionURI(String SOAPActionURI)` Set the soapAction URI.
`void` | `setSOAPService(SOAPService service)`
`void` | `setSOAPVersion(SOAPConstants soapConstants)` Allow the user to set the default SOAP version.
`void` | `setTargetEndpointAddress(String address)` Sets the endpoint address of the target service port.
`void` | `setTargetEndpointAddress(URL address)` Sets the URL of the target Web Service.
`void` | `setTimeout(Integer timeout)`
`void` | `setTransport(Transport trans)` Set the Transport Note: Not part of JAX-RPC specification.
`static void` | `setTransportForProtocol(String protocol, Class transportClass)` Register a Transport that should be used for URLs of the specified protocol.
`void` | `setUsername(String username)` Set the username.
`void` | `setUseSOAPAction(boolean useSOAPAction)` Should soapAction be used?
`boolean` | `useSOAPAction()` Are we using soapAction?

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### msgContext

    protected MessageContext msgContext

### attachmentParts

    protected Vector attachmentParts

### SEND_TYPE_ATTR

    public static final String SEND_TYPE_ATTR

See Also:
  Constant Field Values

### TRANSPORT_NAME

    public static final String TRANSPORT_NAME

See Also:
  Constant Field Values

### TRANSPORT_PROPERTY

    public static final String TRANSPORT_PROPERTY

See Also:
  Constant Field Values

### WSDL_SERVICE

    public static final String WSDL_SERVICE

See Also:
  Constant Field Values

### WSDL_PORT_NAME

    public static final String WSDL_PORT_NAME

See Also:
  Constant Field Values

### JAXRPC_SERVICE

    public static final String JAXRPC_SERVICE

See Also:
  Constant Field Values

### JAXRPC_PORTTYPE_NAME

    public static final String JAXRPC_PORTTYPE_NAME

See Also:
  Constant Field Values

### FAULT_ON_NO_RESPONSE

    public static final boolean FAULT_ON_NO_RESPONSE

See Also:
  Constant Field Values

### ATTACHMENT_ENCAPSULATION_FORMAT

    public static final String ATTACHMENT_ENCAPSULATION_FORMAT

  Property for setting attachment format.

  See Also:
    Constant Field Values

### ATTACHMENT_ENCAPSULATION_FORMAT_MIME

    public static final String ATTACHMENT_ENCAPSULATION_FORMAT_MIME

  Property value for setting attachment format as MIME.

  See Also:
    Constant Field Values

### ATTACHMENT_ENCAPSULATION_FORMAT_DIME

    public static final String ATTACHMENT_ENCAPSULATION_FORMAT_DIME

  Property value for setting attachment format as DIME.

  See Also:
    Constant Field Values

Constructor Detail

### Call

    public Call(Service service)

  Default constructor - not much else to say.

### Call

    public Call(String url)
         throws MalformedURLException

  Build a call from a URL string

Parameters:
  `url` - the target endpoint URL
Throws:
  `MalformedURLException`

### Call

    public Call(URL url)

  Build a call from a URL

Parameters:
  `url` - the target endpoint URL

Method Detail

### setProperty

    public void setProperty(String name,
                            Object value)

  Allows you to set a named property to the passed in value. There are a few known properties (like username, password, etc) that are variables in Call. The rest of the properties are stored in a Hashtable. These common properties should be accessed via the accessors for speed/type safety, but they may still be obtained via this method. It's up to one of the Handlers (or the Axis engine itself) to go looking for one of them.

  Specified by:
    `setProperty` in interface `javax.xml.rpc.Call`
  Parameters:
    `name` - Name of the property
    `value` - Value of the property

### getProperty

    public Object getProperty(String name)

  Returns the value associated with the named property

  Specified by:
    `getProperty` in interface `javax.xml.rpc.Call`
  Returns:
    Object value of the property or null if the property is not set
  Throws:
    `javax.xml.rpc.JAXRPCException` - if the requested property is not a supported property

### removeProperty

    public void removeProperty(String name)

  Removes (if set) the named property.

  Specified by:
    `removeProperty` in interface `javax.xml.rpc.Call`
  Parameters:
    `name` - name of the property to remove

### setScopedProperty

    public void setScopedProperty(String name,
                                  Object value)

  Deprecated.

  Set a scoped property on the call (i.e. one that propagates down into the runtime).

  Deprecated, since setProperty() now does the right thing here. Expect this to disappear in 1.1.

  Parameters:
    `name` -
    `value` -

### getScopedProperty

    public Object getScopedProperty(String name)

  Deprecated.

  Get a scoped property (i.e. one that propagates down into the runtime).

  Deprecated, since there's only one property bag now. Expect this to disappear in 1.1.

  Parameters:
    `name` -
  Returns:

### removeScopedProperty

    public void removeScopedProperty(String name)

  Deprecated.

  Remove a scoped property (i.e. one that propagates down into the runtime).

  Deprecated, since there's only one property bag now. Expect this to disappear in 1.1.

  Parameters:
    `name` -

### getPropertyNames

    public Iterator getPropertyNames()

  Specified by:
    `getPropertyNames` in interface `javax.xml.rpc.Call`

### isPropertySupported

    public boolean isPropertySupported(String name)

### setUsername

    public void setUsername(String username)

  Set the username.

### getUsername

    public String getUsername()

  Get the user name

### setPassword

    public void setPassword(String password)

  Set the password.

### getPassword

    public String getPassword()

  Get the password

### setMaintainSession

    public void setMaintainSession(boolean yesno)

  Determine whether we'd like to track sessions or not. This overrides the default setting from the service. This just passes through the value into the MessageContext. Note: Not part of JAX-RPC specification.

  Parameters:
    `yesno` - true if session state is desired, false if not.

### getMaintainSession

    public boolean getMaintainSession()

  Get the value of maintainSession flag.

### setOperationStyle

    public void setOperationStyle(String operationStyle)

  Set the operation style: "document", "rpc"

  Parameters:
    `operationStyle` - string designating style

### setOperationStyle

    public void setOperationStyle(Style operationStyle)

  Set the operation style

  Parameters:
    `operationStyle` -

### getOperationStyle

    public Style getOperationStyle()

  Get the operation style.

### setOperationUse

    public void setOperationUse(String operationUse)

  Set the operation use: "literal", "encoded"

  Parameters:
    `operationUse` - string designating use

### setOperationUse

    public void setOperationUse(Use operationUse)

  Set the operation use

  Parameters:
    `operationUse` -

### getOperationUse

    public Use getOperationUse()

  Get the operation use.

### setUseSOAPAction

    public void setUseSOAPAction(boolean useSOAPAction)

  Should soapAction be used?

### useSOAPAction

    public boolean useSOAPAction()

  Are we using soapAction?

### setSOAPActionURI

    public void setSOAPActionURI(String SOAPActionURI)
                          throws IllegalArgumentException

  Set the soapAction URI.

  Throws:
    `IllegalArgumentException`

### getSOAPActionURI

    public String getSOAPActionURI()

  Get the soapAction URI.

### setEncodingStyle

    public void setEncodingStyle(String namespaceURI)

  Sets the encoding style to the URL passed in.

  Parameters:
    `namespaceURI` - URI of the encoding to use.

### getEncodingStyle

    public String getEncodingStyle()

  Returns the encoding style as a URI that should be used for the SOAP message.

  Returns:
    String URI of the encoding style to use

### setTargetEndpointAddress

    public void setTargetEndpointAddress(String address)

  Sets the endpoint address of the target service port. This address must correspond to the transport specified in the binding for this Call instance.

  Specified by:
    `setTargetEndpointAddress` in interface `javax.xml.rpc.Call`
  Parameters:
    `address` - - Endpoint address of the target service port; specified as URI

### setTargetEndpointAddress

    public void setTargetEndpointAddress(URL address)

  Sets the URL of the target Web Service.

  Note: Not part of JAX-RPC specification.

  Parameters:
    `address` - URL of the target Web Service

### getTargetEndpointAddress

    public String getTargetEndpointAddress()

  Returns the URL of the target Web Service.

  Specified by:
    `getTargetEndpointAddress` in interface `javax.xml.rpc.Call`
  Returns:
    URL URL of the target Web Service

### getTimeout

    public Integer getTimeout()

### setTimeout

    public void setTimeout(Integer timeout)

### isParameterAndReturnSpecRequired

    public boolean isParameterAndReturnSpecRequired(javax.xml.namespace.QName operationName)

  Is the caller required to provide the parameter and return type specification? If true, then addParameter and setReturnType MUST be called to provide the meta data. If false, then addParameter and setReturnType SHOULD NOT be called because the Call object already has the meta data describing the parameters and return type. If addParameter is called, the specified parameter is added to the end of the list of parameters.

  Specified by:
    `isParameterAndReturnSpecRequired` in interface `javax.xml.rpc.Call`

### addParameter

    public void addParameter(javax.xml.namespace.QName paramName,
                             javax.xml.namespace.QName xmlType,
                             javax.xml.rpc.ParameterMode parameterMode)

  Adds the specified parameter to the list of parameters for the operation associated with this Call object.

  Note: Not part of JAX-RPC specification.

  Parameters:
    `paramName` - Name that will be used for the parameter in the XML
    `xmlType` - XMLType of the parameter
    `parameterMode` - one of IN, OUT or INOUT

### addParameter

    public void addParameter(javax.xml.namespace.QName paramName,
                             javax.xml.namespace.QName xmlType,
                             Class javaType,
                             javax.xml.rpc.ParameterMode parameterMode,
                             boolean inHeader,
                             boolean outHeader)

  Adds the specified parameter to the list of parameters for the operation associated with this Call object.

  Note: Not part of JAX-RPC specification.

  Parameters:
    `paramName` - Name that will be used for the parameter in the XML
    `xmlType` - XMLType of the parameter
    `javaType` - The Java class of the parameter
    `parameterMode` - one of IN, OUT or INOUT

### addParameter

    public void addParameter(javax.xml.namespace.QName paramName,
                             javax.xml.namespace.QName xmlType,
                             Class javaType,
                             javax.xml.rpc.ParameterMode parameterMode)

  Adds the specified parameter to the list of parameters for the operation associated with this Call object.

  Note: Not part of JAX-RPC specification.

  Parameters:
    `paramName` - Name that will be used for the parameter in the XML
    `xmlType` - XMLType of the parameter
    `javaType` - The Java class of the parameter
    `parameterMode` - one of IN, OUT or INOUT

### addParameter

    public void addParameter(String paramName,
                             javax.xml.namespace.QName xmlType,
                             javax.xml.rpc.ParameterMode parameterMode)

  Adds the specified parameter to the list of parameters for the operation associated with this Call object.

  Specified by:
    `addParameter` in interface `javax.xml.rpc.Call`
  Parameters:
    `paramName` - Name that will be used for the parameter in the XML
    `xmlType` - XMLType of the parameter
    `parameterMode` - one of IN, OUT or INOUT

### addParameter

    public void addParameter(String paramName,
                             javax.xml.namespace.QName xmlType,
                             Class javaType,
                             javax.xml.rpc.ParameterMode parameterMode)

  Adds a parameter type and mode for a specific operation. Note that the client code is not required to call any addParameter and setReturnType methods before calling the invoke method. A Call implementation class can determine the parameter types by using the Java reflection and configured type mapping registry.

  Specified by:
    `addParameter` in interface `javax.xml.rpc.Call`
  Parameters:
    `paramName` - - Name of the parameter
    `xmlType` - - XML datatype of the parameter
    `javaType` - - The Java class of the parameter
    `parameterMode` - - Mode of the parameter-whether IN, OUT or INOUT
  Throws:
    `javax.xml.rpc.JAXRPCException` - - if isParameterAndReturnSpecRequired returns false, then addParameter MAY throw JAXRPCException....actually Axis allows modification in such cases

### addParameterAsHeader

    public void addParameterAsHeader(javax.xml.namespace.QName paramName,
                                     javax.xml.namespace.QName xmlType,
                                     Class javaType,
                                     javax.xml.rpc.ParameterMode parameterMode,
                                     javax.xml.rpc.ParameterMode headerMode)

  Adds a parameter type as a soap:header.

  Parameters:
    `paramName` - - Name of the parameter
    `xmlType` - - XML datatype of the parameter
    `javaType` - - The Java class of the parameter
    `parameterMode` - - Mode of the parameter-whether IN, OUT or INOUT
    `headerMode` - - Mode of the header. Even if this is an INOUT parameter, it need not be in the header in both directions.
  Throws:
    `javax.xml.rpc.JAXRPCException` - - if isParameterAndReturnSpecRequired returns false, then addParameter MAY throw JAXRPCException....actually Axis allows modification in such cases

### getParameterTypeByName

    public javax.xml.namespace.QName getParameterTypeByName(String paramName)

  Return the QName of the type of the parameters with the given name.

  Specified by:
    `getParameterTypeByName` in interface `javax.xml.rpc.Call`
  Parameters:
    `paramName` - name of the parameter to return
  Returns:
    XMLType XMLType of paramName, or null if not found.

### getParameterTypeByQName

    public javax.xml.namespace.QName getParameterTypeByQName(javax.xml.namespace.QName paramQName)

  Return the QName of the type of the parameters with the given name.

  Note: Not part of JAX-RPC specification.

  Parameters:
    `paramQName` - QName of the parameter to return
  Returns:
    XMLType XMLType of paramQName, or null if not found.

### setReturnType

    public void setReturnType(javax.xml.namespace.QName returnType)

  Sets the return type of the operation associated with this Call object.

  Specified by:
    `setReturnType` in interface `javax.xml.rpc.Call`
  Parameters:
    `returnType` - QName of the return value type.

### setReturnType

    public void setReturnType(javax.xml.namespace.QName xmlType,
                              Class javaType)

  Sets the return type for a specific operation.

  Specified by:
    `setReturnType` in interface `javax.xml.rpc.Call`
  Parameters:
    `xmlType` - - QName of the data type of the return value
    `javaType` - - Java class of the return value
  Throws:
    `javax.xml.rpc.JAXRPCException` - - if isParameterAndReturnSpecRequired returns false, then setReturnType MAY throw JAXRPCException...Axis allows modification without throwing the exception.

### setReturnTypeAsHeader

    public void setReturnTypeAsHeader(javax.xml.namespace.QName xmlType)

  Set the return type as a header

### setReturnTypeAsHeader

    public void setReturnTypeAsHeader(javax.xml.namespace.QName xmlType,
                                      Class javaType)

  Set the return type as a header

### getReturnType

    public javax.xml.namespace.QName getReturnType()

  Returns the QName of the type of the return value of this Call - or null if not set.

  Note: Not part of JAX-RPC specification.

  Specified by:
    `getReturnType` in interface `javax.xml.rpc.Call`
  Returns:
    the XMLType specified for this Call (or null).

### setReturnQName

    public void setReturnQName(javax.xml.namespace.QName qname)

  Set the QName of the return element

  NOT part of JAX-RPC

### setReturnClass

    public void setReturnClass(Class cls)

  Sets the desired return Java Class. This is a convenience method which will cause the Call to automatically convert return values into a desired class if possible. For instance, we return object arrays by default now for SOAP arrays - you could specify:

  setReturnClass(Vector.class)

  and you'd get a Vector back from invoke() instead of having to do the conversion yourself.

  Note: Not part of JAX-RPC specification. To be JAX-RPC compliant, use setReturnType(QName, Class).

  Parameters:
    `cls` - the desired return class.

### removeAllParameters

    public void removeAllParameters()

  Clears the list of parameters.

  Specified by:
    `removeAllParameters` in interface `javax.xml.rpc.Call`
  Throws:
    `javax.xml.rpc.JAXRPCException` - - if isParameterAndReturnSpecRequired returns false, then removeAllParameters MAY throw JAXRPCException...Axis allows modification to the Call object without throwing an exception.

### getOperationName

    public javax.xml.namespace.QName getOperationName()

  Returns the operation name associated with this Call object.

  Specified by:
    `getOperationName` in interface `javax.xml.rpc.Call`
  Returns:
    String Name of the operation or null if not set.

### setOperationName

    public void setOperationName(javax.xml.namespace.QName opName)

  Sets the operation name associated with this Call object. This will not check the WSDL (if there is WSDL) to make sure that it's a valid operation name.

  Specified by:
    `setOperationName` in interface `javax.xml.rpc.Call`
  Parameters:
    `opName` - Name of the operation.

### setOperationName

    public void setOperationName(String opName)

  This is a convenience method. If the user doesn't care about the QName of the operation, the user can call this method, which converts a String operation name to a QName.

### setOperation

    public void setOperation(String opName)

  Prefill as much info from the WSDL as it can. Right now it's SOAPAction, operation qname, parameter types and return type of the Web Service.

  This methods considers that port name and target endpoint address have already been set. This is useful when you want to use the same Call instance for several calls on the same Port

  Note: Not part of JAX-RPC specification.

  Parameters:
    `opName` - Operation(method) that's going to be invoked

### getWsdlOpName

    protected String getWsdlOpName(String javaOpName)

  The default implementation simply returns the java operation name. A ws4ee implementation would take the jaxrpc-mapping file into consideration and return the corresponding wsdl operation name

### setOperation

    public void setOperation(javax.xml.namespace.QName portName,
                             String opName)

  prefill as much info from the WSDL as it can. Right now it's target URL, SOAPAction, Parameter types, and return type of the Web Service.

  If wsdl is not present, this function set port name and operation name and does not modify target endpoint address.

  Note: Not part of JAX-RPC specification.

  Parameters:
    `portName` - PortName in the WSDL doc to search for
    `opName` - Operation(method) that's going to be invoked

### getPortName

    public javax.xml.namespace.QName getPortName()

  Returns the fully qualified name of the port for this Call object (if there is one).

  Returns:
    QName Fully qualified name of the port (or null if not set)

### setPortName

    public void setPortName(javax.xml.namespace.QName portName)

  Sets the port name of this Call object. This call will not set any additional fields, nor will it do any checking to verify that this port name is actually defined in the WSDL - for now anyway.

  Parameters:
    `portName` - Fully qualified name of the port

### getPortTypeName

    public javax.xml.namespace.QName getPortTypeName()

  Deprecated. This is really the service's port name, not portType name. Use getPortName instead.

  Returns the fully qualified name of the port for this Call object (if there is one).

  Specified by:
    `getPortTypeName` in interface `javax.xml.rpc.Call`
  Returns:
    QName Fully qualified name of the port

### setPortTypeName

    public void setPortTypeName(javax.xml.namespace.QName portType)

  Deprecated. This is really the service's port name, not portType name. Use setPortName instead.

  Sets the port name of this Call object. This call will not set any additional fields, nor will it do any checking to verify that this port type is actually defined in the WSDL - for now anyway.

  Specified by:
    `setPortTypeName` in interface `javax.xml.rpc.Call`
  Parameters:
    `portType` - Fully qualified name of the portType

### setSOAPVersion

    public void setSOAPVersion(SOAPConstants soapConstants)

  Allow the user to set the default SOAP version. For SOAP 1.2, pass SOAPConstants.SOAP12_CONSTANTS.

  Parameters:
    `soapConstants` - the SOAPConstants object representing the correct version

### invoke

    public Object invoke(javax.xml.namespace.QName operationName,
                         Object[] params)
                  throws RemoteException

  Invokes a specific operation using a synchronous request-response interaction mode. The invoke method takes as parameters the object values corresponding to these defined parameter types. Implementation of the invoke method must check whether the passed parameter values correspond to the number, order and types of parameters specified in the corresponding operation specification.

  Specified by:
    `invoke` in interface `javax.xml.rpc.Call`
  Parameters:
    `operationName` - - Name of the operation to invoke
    `params` - - Parameters for this invocation
  Returns:
    the value returned from the other end.
  Throws:
    `RemoteException` - - if there is any error in the remote method invocation or if the Call object is not configured properly.

### invoke

    public Object invoke(Object[] params)
                  throws RemoteException

  Invokes the operation associated with this Call object using the passed in parameters as the arguments to the method.

  For Messaging (ie. non-RPC) the params argument should be an array of SOAPBodyElements. All of them need to be SOAPBodyElements, if any of them are not this method will default back to RPC. In the Messaging case the return value will be a vector of SOAPBodyElements.

  Specified by:
    `invoke` in interface `javax.xml.rpc.Call`
  Parameters:
    `params` - Array of parameters to invoke the Web Service with
  Returns:
    Object Return value of the operation/method - or null
  Throws:
    `RemoteException` - if there's an error

### invokeOneWay

    public void invokeOneWay(Object[] params)

  Invokes the operation associated with this Call object using the passed in parameters as the arguments to the method. This will return immediately rather than waiting for the server to complete its processing.

  NOTE: the return immediately part isn't implemented yet

  Specified by:
    `invokeOneWay` in interface `javax.xml.rpc.Call`
  Parameters:
    `params` - Array of parameters to invoke the Web Service with
  Throws:
    `javax.xml.rpc.JAXRPCException` - is there's an error

### invoke

    public SOAPEnvelopeAxisImpl invoke(SOAPEnvelopeAxisImpl env)
                                throws RemoteException

  Invoke the service with a custom SOAPEnvelope.

  Note: Not part of JAX-RPC specification.

  Parameters:
    `env` - a SOAPEnvelope to send.
  Throws:
    `AxisFault`
    `RemoteException`

### setTransportForProtocol

    public static void setTransportForProtocol(String protocol,
                                               Class transportClass)

  Register a Transport that should be used for URLs of the specified protocol.

  Note: Not part of JAX-RPC specification.

  Parameters:
    `protocol` - the URL protocol (i.e. "tcp" for "tcp://" urls)
    `transportClass` - the class of a Transport type which will be used for matching URLs.

### initialize

    public static void initialize()

  Set up the default transport URL mappings.

  This must be called BEFORE doing non-standard URL parsing (i.e. if you want the system to accept a "local:" URL). This is why the Options class calls it before parsing the command-line URL argument.

  Note: Not part of JAX-RPC specification.

### addTransportPackage

    public static void addTransportPackage(String packageName)

  Add a package to the system protocol handler search path. This enables users to create their own URLStreamHandler classes, and thus allow custom protocols to be used in Axis (typically on the client command line).

  For instance, if you add "samples.transport" to the packages property, and have a class samples.transport.tcp.Handler, the system will be able to parse URLs of the form "tcp://host:port..."

  Note: Not part of JAX-RPC specification.

  Parameters:
    `packageName` - the package in which to search for protocol names.

### setTransport

    public void setTransport(Transport trans)

  Set the Transport

  Note: Not part of JAX-RPC specification.

  Parameters:
    `trans` - the Transport object we'll use to set up MessageContext properties.

### getTransportForProtocol

    public Transport getTransportForProtocol(String protocol)

  Get the Transport registered for the given protocol.

  Note: Not part of JAX-RPC specification.

  Parameters:
    `protocol` - a protocol such as "http" or "local" which may have a Transport object associated with it.
  Returns:
    the Transport registered for this protocol, or null if none.

### setRequestMessage

    public void setRequestMessage(Message msg)

  Directly set the request message in our MessageContext.

  This allows custom message creation.

  Note: Not part of JAX-RPC specification.

  Parameters:
    `msg` - the new request message.

### addAttachmentParts

    protected void addAttachmentParts(Message msg)

  Stub out to allow ws4ee layer to add attachments to the message

### getResponseMessage

    public Message getResponseMessage()

  Directly get the response message in our MessageContext.

  Shortcut for having to go thru the msgContext

  Note: Not part of JAX-RPC specification.

  Returns:
    the response Message object in the msgContext

### getMessageContext

    public MessageContext getMessageContext()

  Obtain a reference to our MessageContext.

  Note: Not part of JAX-RPC specification.

  Returns:
    the MessageContext.

### addHeader

    public void addHeader(SOAPHeaderElementAxisImpl header)

  Add a header which should be inserted into each outgoing message we generate.

  Note: Not part of JAX-RPC specification.

  Parameters:
    `header` - a SOAPHeaderElement to be inserted into messages

### clearHeaders

    public void clearHeaders()

  Clear the list of headers which we insert into each message

  Note: Not part of JAX-RPC specification.

### getTypeMapping

    public TypeMapping getTypeMapping()

### registerTypeMapping

    public void registerTypeMapping(Class javaType,
                                    javax.xml.namespace.QName xmlType,
                                    SerializerFactory sf,
                                    DeserializerFactory df)

  Register type mapping information for serialization/deserialization

  Note: Not part of JAX-RPC specification.

  Parameters:
    `javaType` - is the Java class of the data type.
    `xmlType` - the xsi:type QName of the associated XML type.

### registerTypeMapping

    public void registerTypeMapping(Class javaType,
                                    javax.xml.namespace.QName xmlType,
                                    SerializerFactory sf,
                                    DeserializerFactory df,
                                    boolean force)

  Register type mapping information for serialization/deserialization

  Note: Not part of JAX-RPC specification.

  Parameters:
    `javaType` - is the Java class of the data type.
    `xmlType` - the xsi:type QName of the associated XML type.
    `force` - Indicates whether to add the information if already registered.

### registerTypeMapping

    public void registerTypeMapping(Class javaType,
                                    javax.xml.namespace.QName xmlType,
                                    Class sfClass,
                                    Class dfClass)

### registerTypeMapping

    public void registerTypeMapping(Class javaType,
                                    javax.xml.namespace.QName xmlType,
                                    Class sfClass,
                                    Class dfClass,
                                    boolean force)

### invoke

    public Object invoke(String namespace,
                         String method,
                         Object[] args)
                  throws AxisFault

  Invoke an RPC service with a method name and arguments.

  This will call the service, serializing all the arguments, and then deserialize the return value.

  Note: Not part of JAX-RPC specification.

  Parameters:
    `namespace` - the desired namespace URI of the method element
    `method` - the method name
    `args` - an array of Objects representing the arguments to the invoked method. If any of these objects are RPCParams, Axis will use the embedded name of the RPCParam as the name of the parameter. Otherwise, we will serialize each argument as an XML element called "arg".
  Returns:
    a deserialized Java Object containing the return value
  Throws:
    `AxisFault`

### invoke

    public Object invoke(String method,
                         Object[] args)
                  throws AxisFault

  Convenience method to invoke a method with a default (empty) namespace. Calls invoke() above.

  Note: Not part of JAX-RPC specification.

  Parameters:
    `method` - the method name
    `args` - an array of Objects representing the arguments to the invoked method. If any of these objects are RPCParams, Axis will use the embedded name of the RPCParam as the name of the parameter. Otherwise, we will serialize each argument as an XML element called "arg".
  Returns:
    a deserialized Java Object containing the return value
  Throws:
    `AxisFault`

### invoke

    public Object invoke(RPCElement body)
                  throws AxisFault

  Invoke an RPC service with a pre-constructed RPCElement.

  Note: Not part of JAX-RPC specification.

  Parameters:
    `body` - an RPCElement containing all the information about this call.
  Returns:
    a deserialized Java Object containing the return value
  Throws:
    `AxisFault`

### setOption

    public void setOption(String name,
                          Object value)

  Set engine option.

  Note: Not part of JAX-RPC specification.

### invoke

    public void invoke()
                throws AxisFault

  Invoke this Call with its established MessageContext (perhaps because you called this.setRequestMessage())

  Note: Not part of JAX-RPC specification.

  Throws:
    `AxisFault`

### getOutputParams

    public Map getOutputParams()

  Get the output parameters (if any) from the last invocation.

  NOTE that the params returned are all RPCParams, containing name and value - if you want the value, you'll need to call param.getValue().

  Specified by:
    `getOutputParams` in interface `javax.xml.rpc.Call`
  Returns:
    Vector of RPCParams

### getOutputValues

    public List getOutputValues()

  Returns a List values for the output parameters of the last invoked operation.

  Specified by:
    `getOutputValues` in interface `javax.xml.rpc.Call`
  Returns:
    Values for the output parameters. An empty List is returned if there are no output values.
  Throws:
    `javax.xml.rpc.JAXRPCException` - - If this method is invoked for a one-way operation or is invoked before any invoke method has been called.

### getService

    public Service getService()

  Get the Service object associated with this Call object.

  Note: Not part of JAX-RPC specification.

  Returns:
    Service the Service object this Call object is associated with

### setSOAPService

    public void setSOAPService(SOAPService service)

### setClientHandlers

    public void setClientHandlers(Handler reqHandler,
                                  Handler respHandler)

  Sets the client-side request and response Handlers. This is handy for programatically setting up client-side work without deploying via WSDD or the EngineConfiguration mechanism.

### addAttachmentPart

    public void addAttachmentPart(Object attachment)

  This method adds an attachment.

  Note: Not part of JAX-RPC specification.

  Throws:
    `RuntimeException` - if there is no support for attachments.

### addFault

    public void addFault(javax.xml.namespace.QName qname,
                         Class cls,
                         javax.xml.namespace.QName xmlType,
                         boolean isComplex)

  Add a fault for this operation

  Note: Not part of JAX-RPC specificaion

### setOperation

    public void setOperation(OperationDesc operation)

  Hand a complete OperationDesc to the Call, and note that this was done so that others don't try to mess with it by calling addParameter, setReturnType, etc.

  Parameters:
    `operation` - the OperationDesc to associate with this call.

### getOperation

    public OperationDesc getOperation()

### clearOperation

    public void clearOperation()

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002 JBoss Group, LLC. All Rights Reserved.